/*************************************************/
/* `QNX́AԊONXgĂ */
/*                       written by shusaku sone */
/*************************************************/

import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Display;
import com.nttdocomo.device.*;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Frame;


public class ChoroQ extends IR{
	
	//ChroQ State
	private static final byte START            =  0; // start(not use)       0000
	private static final byte FORWARD          =  1; // forward              0001
	private static final byte BACK             =  2; // back                 0010
	private static final byte LEFT             =  3; // left                 0011
	private static final byte RIGHT            =  4; // right                0100
	private static final byte DUSH_FORWARD     =  5; // dush forward         0101
	private static final byte FORWARD_LEFT     =  6; // forward left         0110
	private static final byte FORWARD_RIGHT    =  7; // forward right        0111
	private static final byte DUSH_F_L         =  8; // dush forward left    1000
	private static final byte DUSH_F_R         =  9; // dush forward right   1001
	private static final byte BACK_LEFT        =  10; // back left            1010
	private static final byte BACK_RIGHT       =  11; // back right           1011
	private static final byte DUSH_BACK        =  12; // dush back            1100
	private static final byte DUSH_B_L         =  13; // dush back left       1101
	private static final byte DUSH_B_R         =  14; // dush back right      1110
	private static final byte END              =  15; // end(not use)         1111

	private static final byte AS_FORWARD	   =  1; // Oi(xZT[gp)
	private static final byte AS_BACK		   =  0; // (xZT[gp)
	
	private static int carState=0;
    
	//channel
    //Ach 00
    //Bch 01
    //Cch 10
    //Dch 11
    public static byte CH    =  0; // Ach
	
	// xZT[gp̐is
	public static byte handling = AS_FORWARD;
	public static boolean asFlag = false;
	
	static IrCanvas tempCanvas;
	
	/**
	  * RXgN^
	  */
	public ChoroQ(IrCanvas temp){
		super(END+1);	
		tempCanvas=temp;
		init();
		
	}
	
	/**
	  *  `Q̏
	  */
	public void init(){
		
		//x̏
		CH=0;
		initLabel();
		
		int CARRIER_HI = 5000 / FREQ ;
		int CARRIER_LO = 5000 / FREQ ;
		//LAg̐ݒ
		//ORDER@[0.1usec]
		IR.setCarrier(CARRIER_HI, CARRIER_LO);
		
		//PPM̐ݒ
		//HI̒0or1߂
		//ORDER@[usec]
		int PULSE_HI_0= 550;
		int PULSE_LO_0= 450;
		
		int PULSE_HI_1= 950;
		int PULSE_LO_1= 450;
		
		//_0̔g`
		IR.setCode0(IR.PATTERN_LH, PULSE_HI_0, PULSE_LO_0);
		//_1̔g`
		IR.setCode1(IR.PATTERN_LH, PULSE_HI_1, PULSE_LO_1);
		
		initFrame(CH);
	}
	
	/**
	  *  ԊÕt[̏
	  */
	private static void initFrame(byte ch){
		byte[] state=new byte[1];
		
		for(byte i=START;i<END;i++){
				state[0] = (byte)((ch << 4 | i) << 2);
				FRAME[i].setFrameData(state, 6);
				FRAME[i].setFrameDuration(807); // x0.1 msec
				FRAME[i].setStartHighDuration(1880); // usec
				FRAME[i].setStartLowDuration(0);
				FRAME[i].setStopHighDuration(0);
				FRAME[i].setRepeatCount(1);
		}
		
	}
	
	/**
	  *  Ԃ̏ԂɉĐԊO𑗂
	  */
	public void send(int state){
	  IR.stop();
	 switch(state){
	   case Display.KEY_UP:
	    if(handling == AS_FORWARD) carState=FORWARD;
		else carState=BACK;
	  break;
			
	  case Display.KEY_DOWN:
		carState=BACK;
	  break;
	
	  case Display.KEY_LEFT:
	   if(handling == AS_FORWARD) carState=FORWARD_LEFT;
	   else carState=BACK_LEFT;
	  break;
			
	  case Display.KEY_RIGHT:
	   if(handling == AS_FORWARD) carState=FORWARD_RIGHT;
	   else carState=BACK_RIGHT;
	  break;
		  
	  case Display.KEY_UPPER_LEFT:
	   if(handling == AS_FORWARD) carState=FORWARD_LEFT;
	   else carState=BACK_LEFT;
	  break;
		  
	  case Display.KEY_UPPER_RIGHT:
	   if(handling == AS_FORWARD) carState=FORWARD_RIGHT;
	   else carState=BACK_RIGHT;
	  break;
			
	  case Display.KEY_LOWER_LEFT:
	   carState=BACK_LEFT;
	  break;
		  
	  case Display.KEY_LOWER_RIGHT:
	   carState=BACK_RIGHT;
	  break;
			
	  case Display.KEY_SELECT:
	   if(asFlag){
	    if(handling == AS_FORWARD){
		 handling = AS_BACK;
		}else{
		 handling = AS_FORWARD;
	    }
	   }
	   state = 0;
	  break;
     }//end of switch
		
    if(state!=0){
	 SEND[0]=FRAME[carState];
	 try{
	  IR.send(1,SEND,60);
     }catch(Exception e){
	  System.out.println("Excep at IR.send:"+e.toString()+ "st :"+state);
	 }
    }
   }

   /**
     * ķ̏
     */
   public static void initLabel(){
		CH=0;
		tempCanvas.setSoftLabel(Frame.SOFT_KEY_1, "");
		tempCanvas.setSoftLabel(Frame.SOFT_KEY_2, "Ach");
   }
	
   /**
     * `Q̃oh̐ݒ
     */
   public static void bandChange(){
		IR.stop();
		CH++;
		if (CH==4) CH=0;
		initFrame(CH);
		
		switch (CH) {
			case 0:
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_2, "Ach");
			break;
			case 1:
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_2, "Bch");
			break;
			case 2:
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_2, "Cch");
			break;
			case 3:
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_2, "Dch");
			break;
			default:
			break;
		}
		
	}
	

	/**
	  *  L[orxZT؂ւ
	  */
	public static boolean handlingChange(){
		IR.stop();
		handling=AS_FORWARD;

		if(asFlag){
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_1, "");
			asFlag = false;
		}
		else{
			tempCanvas.setSoftLabel(Frame.SOFT_KEY_1, "ݻ");
			asFlag = true;
		}

		return asFlag;
	}
}